#include "externals.hh"
#include "globals.hh"

#include "filewatcher.hh"
#include "profiling.hh"
#include "texture.hh"
#include "shaders.hh"
#include "window.hh"
#include "odbg.hh"
#include "sync.hh"


T_OwnPtr< T_FilesWatcher > Globals::watcher_;
T_OwnPtr< T_Window > Globals::window_;
T_OwnPtr< T_Profiler > Globals::profiler_;
T_OwnPtr< T_SyncManager > Globals::sync_;
T_OwnPtr< T_TextureManager > Globals::textures_;
T_OwnPtr< T_ShaderManager > Globals::shaders_;
T_OwnPtr< T_OutputDebugger > Globals::odbg_;


void Globals::Init( )
{
	watcher_ = NewOwned< T_FilesWatcher >( );
	window_ = NewOwned< T_Window >( );
	profiler_ = NewOwned< T_Profiler >( );
	sync_ = NewOwned< T_SyncManager >( );
	textures_ = NewOwned< T_TextureManager >( );
	shaders_ = NewOwned< T_ShaderManager >( );
	odbg_ = NewOwned< T_OutputDebugger >( );
}

void Globals::Shutdown( )
{
	odbg_.clear( );
	shaders_.clear( );
	textures_.clear( );
	sync_.clear( );
	profiler_.clear( );
	window_.clear( );
	watcher_.clear( );
}
